/***************************************************************************
                          processexec.cpp  -  description
                             -------------------
    begin                : s�b abr 27 2002
    copyright            : (C) 2002 by asdf
    email                : dsf
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>

#include <qdebug.h>

#include "general.h"
#include "processexec.h"


ProcessExec::ProcessExec(): KProcess()
{
 clearData();
 
 connect( this, SIGNAL(readyReadStandardOutput()),this, SLOT(slotReceivedStdout()) );
 connect( this, SIGNAL(readyReadStandardError()),this, SLOT(slotReceivedStderr()) );
}

ProcessExec::~ProcessExec()
{
//  qDebug() << "\033[91m" << "qDebug(): ProcessExec::~ProcessExec()" << this << "\033[0m";
}

bool ProcessExec::run()
{
//  qDebug() << "\033[91m" << "qDebug(): ProcessExec::run()" << "\033[0m";
  
 clearData();
 
 setOutputChannelMode(KProcess::SeparateChannels);
 
 start();
 return true;
}

bool ProcessExec::runAndWait()
{
//  qDebug() << "\033[91m" << "qDebug(): ProcessExec::runAndWait()" << "\033[0m";
  
 clearData();
 
 setOutputChannelMode(KProcess::SeparateChannels);
 
 execute();
 
 return true;
}

void ProcessExec::slotReceivedStdout()
{
//  setReadChannel(KProcess::StandardOutput);
  
  buffer.append ( qsFL1( readAllStandardOutput() ) );
  
//  qDebug() << "\033[91m" << "qDebug(): ProcessExec::slotReceivedStdout()" << buffer << "\033[0m";
}

void ProcessExec::slotReceivedStderr()
{
  fErrors= true;
  
//  setReadChannel(KProcess::StandardError);
  
  buffer.append ( qsFL1( readAllStandardError() ) );
  
//  qDebug() << "\033[91m" << "qDebug(): ProcessExec::slotReceivedStderr()" << buffer << "\033[0m";
  
}

